function createCookie(name,value,days) {
    var expires = "";
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days*24*60*60*1000));
        expires = "; expires=" + date.toUTCString();
    }
    document.cookie = name + "=" + value + expires + "; path=/";
}

function readCookie(name) {
    var nameEQ = name + "=";
    var ca = document.cookie.split(';');
    for(var i=0;i < ca.length;i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1,c.length);
        if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
    }
    return null;
}

function eraseCookie(name) {
    createCookie(name,"",-1);
}

var app = new Vue({
	el : '#wrapper',
	data : {
		level : 1,
		score : 0,
		name  : [],
		keyboard : [],
		nameLength : 0,
		activeName : '',
		isMatch : false,
		players : [],
		player : [],
		teams : [],
		tempTeams : [],
		hint : false,
		welcome : true,
		previewLogo : false,
		tip : {
			Name : '',
			Nationality : '',
			Position : ''
		},
		loading : true
	},
	methods : {
		levelUp : function(){
			app.level++;
		},
		scoreUp : function(){
			app.score+=15;
		},
		shuffle : function(a) {
		    var j, x, i;
		    for (i = a.length; i; i--) {
		        j = Math.floor(Math.random() * i);
		        x = a[i - 1];
		        a[i - 1] = a[j];
		        a[j] = x;
		    }

		    return a;
		},
		randomKeyboard : function(name, team){
			app.name = [];
			app.keyboard = [];
			app.nameLength = 0;
			app.activeName = name;

			for (i=0;i<name.length;i++) {
				app.name.push({key : '_'});
			}

			nameSplit = name.split('');

			for(character in nameSplit){
				app.keyboard.push({key : nameSplit[character], selected : false, disabled : false});
			}

			for (i=0;i<14-name.length;i++) {
				app.keyboard.push({key : this.randomCharacter(), selected : false, disabled : false});
			}

			app.keyboard = app.shuffle(app.keyboard);

			count = 0;
			app.teams = [];
			app.tempTeams = [];
			for(key in team){
				item = team[key];
				/*

				if(key == 3 && team.length < 5){
					console.log('push');
					app.teams.push({empty : true});
					app.teams.push({empty : true});
				}
				*/

				app.teams.push({logo : item, empty : false, index:count});
				//app.tempTeams.push({logo : true});
				//count++;
			}

			/*
			temp = app.teams[3];
			if(temp && team.length > 5){
				app.teams[3] = app.teams[5];
				app.teams[5] = temp;
			}

			for(i=0;i<9-app.teams.length;i++){
				app.teams.push({empty : true});
			}
			*/

			calculateScale();
		},
		randomCharacter : function(){
			possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
			return possible.charAt(Math.floor(Math.random() * possible.length));
		},
		_isMatch : function(){
			output = '';

			for(character in app.name){
				character = app.name[character].key;

				output+=character;
			}

			if(output == app.activeName){
				return true;
			}else{
				return false;
			}
		},
		addKey : function(item, index){
			if(item.disabled){
				
			}else if(app.nameLength < app.activeName.length){
				item.disabled = true;
				if(app.nameLength < app.activeName.length){
					app.name[app.nameLength].key = item.key;
					app.name[app.nameLength].index = index;
					app.nameLength++;
				}

				app.isMatch = app._isMatch();

				if(app.isMatch){
					setTimeout(function(){
						app.isMatch = false;
						app.nextLevel();
					}, 1500);
				}
			}
		},
		removeKey : function(item){
			item = app.name[app.nameLength-1];

			if(app.nameLength > 0){

				app.keyboard[item.index].disabled = false;

				app.nameLength--;
				app.name[app.nameLength].key = '_';
			}
		},
		nextLevel : function(){
			if(app.player){
				app.levelUp();
				app.scoreUp();

				app.player = app.players[app.level-1];

				if(app.players.length > app.level){
					teams = app.player.Teams;
					teams = teams.search(',') > 0 ? teams.split(',') : [teams]
					app.randomKeyboard(app.secure(app.player.Surname), teams);

					app.tip = {
						Name : '',
						Nationality : '',
						Position : ''
					};
				}
			}

			if(app.players.length < app.level){
				//app.service();
			}

			app.save();
		},
		useTip : function(hintType, validScore){
			if(app.score >= validScore){
				if(hintType == 'Name' && !app.tip.Name){
					app.tip.Name = app.player.Name;
					app.score-=50;
				}

				if(hintType == 'Nationality' && !app.tip.Nationality){
					app.tip.Nationality = app.player.Nationality;
					app.score-=15;
				}

				if(hintType == 'Position' && !app.tip.Position){
					app.tip.Position = app.player.Position;
					app.score-=20;
				}
			}
		},
		secure : function(character){
			String.prototype.turkishToUpper = function(){
			    var string = this;
			    var letters = { "i": "I", "ş": "Ş", "ğ": "Ğ", "ü": "Ü", "ö": "Ö", "ç": "Ç", "ı": "I" };
			    string = string.replace(/(([iışğüçö]))+/g, function(letter){ return letters[letter]; })
			    return string.toUpperCase();
			}

			return character.turkishToUpper();
		},
		get : function(url, callback){
			var xmlhttp;
		    // compatible with IE7+, Firefox, Chrome, Opera, Safari
		    xmlhttp = new XMLHttpRequest();
		    xmlhttp.onreadystatechange = function(){
		        if (xmlhttp.readyState == 4 && xmlhttp.status == 200){
		            callback(xmlhttp.responseText);
		        }
		    }
		    xmlhttp.open("GET", url, true);
		    xmlhttp.send();
		},
		service : function(){
			app.get('http://playerhistoryquiz.csdlabapps.com/Service/AllQuestions', function(response){
				response = JSON.parse(response);
				app.players = response;
				app.loading = false;

				app.player = app.players[app.level-1];
				teams = app.player.Teams;
				teams = teams.search(',') > 0 ? teams.split(',') : [teams]
				app.randomKeyboard(app.secure(app.player.Surname), teams);
			});
		},
		init : function(){
			if(app.players.length <= app.level){
				app.service();
			}

			if(!app.load()){
				app.service();
			}
		},
		save : function(){
			try{
				window.localStorage.setItem("session", JSON.stringify({
					level : app.level,
					score : app.score,
					players : app.players
				}));
			}catch(e){
				createCookie("session", JSON.stringify({
					level : app.level,
					score : app.score,
					players : app.players
				}));
			}
		},
		load : function(){
			try{
				session = JSON.parse(window.localStorage.getItem("session"));
			}catch(e){
				session = JSON.parse(readCookie('session'));
			}

			if(session){
				app.level = session.level;
				app.score = session.score;
				app.players = session.players;
				app.loading = false;
				app.welcome = false;

				app.player = app.players[app.level-1];
				teams = app.player.Teams;
				teams = teams.search(',') > 0 ? teams.split(',') : [teams]
				app.randomKeyboard(app.secure(app.player.Surname), teams);

				return true;
			}else{
				return false;
			}
		},
		rightFollow : function(index){
			return (index == 0 && app.tempTeams.length > 1) || index == 1 || (index > 5 && index < 7) || (index == 7 && app.tempTeams.length > 8);
		},
		bottomFollow : function(index){
			return (index == 2 && app.tempTeams.length > 3) || (index == 3 && app.tempTeams.length > 6);
		},
		leftFollow : function(index){
			return index == 4 || (index == 5 && app.tempTeams.length > 5);
		}
	}
});

function calculateScale(){
	scale = window.innerWidth/320;
	document.getElementById('logos').style.transform = 'scale(' + scale + ')';
}

var isPendingInterstitial = false;
var isAutoshowInterstitial = false;

function prepareInterstitialAd() {
    if (!isPendingInterstitial) { // We won't ask for another interstitial ad if we already have an available one
        admob.requestInterstitialAd({
            autoShowInterstitial: isAutoshowInterstitial
        });
    }
}

function onAdLoadedEvent(e) {
    if (e.adType === admob.AD_TYPE.INTERSTITIAL && !isAutoshowInterstitial) {
        isPendingInterstitial = true;
    }
}

function onDeviceReady() {
    document.removeEventListener('deviceready', onDeviceReady, false);

    admob.setOptions({
        interstitialAdId:     "ca-app-pub-2903326829382513~3791596781"
    });

    document.addEventListener(admob.events.onAdLoaded, onAdLoadedEvent);
    prepareIntestitialAd();
}

document.addEventListener("deviceready", onDeviceReady, false);

function showInterstitialAd() {
    if (isPendingInterstitial) {
        admob.showInterstitialAd(function () {
                isPendingInterstitial = false;
                isAutoshowInterstitial = false;
                prepareInterstitialAd();
        });
    } else {
        // The interstitial is not prepared, so in this case, we want to show the interstitial as soon as possible
        isAutoshowInterstitial = true;
        admob.requestInterstitialAd({
            autoShowInterstitial: isAutoshowInterstitial
        });
    }
}

window.onload = function(){
	app.init();

	setInterval(function(){
		showInterstitialAd();
	}, 120000);
}